import * as squint_core from 'squint-cljs/core.js';
import * as commands from '@codemirror/commands';
import * as u from './util.mjs';
import * as sel from './selections.mjs';
import * as n from './node.mjs';
import * as format from './extensions/formatting.mjs';
import * as sel_history from './extensions/selection_history.mjs';
var view_command = (function (f) {
return function (p__320) {
let map__12 = p__320;
let state3 = squint_core.get(map__12, "state");
let dispatch4 = squint_core.get(map__12, "dispatch");
let G__3215 = f(state3);
let test__23632__auto__6 = squint_core.nil_QMARK_(G__3215);
if (squint_core.t(test__23632__auto__6)) {
null} else {
dispatch4(G__3215)};
return true;
};
});
var scoped_view_command = (function (f) {
return function (p__322) {
let map__12 = p__322;
let state3 = squint_core.get(map__12, "state");
let dispatch4 = squint_core.get(map__12, "dispatch");
let test__23632__auto__5 = n.within_program_QMARK_(state3);
if (squint_core.t(test__23632__auto__5)) {
let G__3236 = f(state3);
let test__23632__auto__7 = squint_core.nil_QMARK_(G__3236);
if (squint_core.t(test__23632__auto__7)) {
null} else {
dispatch4(G__3236)};
return true;} else {
return false;}
};
});
var unwrap_STAR_ = (function (state) {
return u.update_ranges(state, (function (p__324) {
let map__12 = p__324;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
let temp__25223__auto__7 = (function () {
 let G__3258 = n.tree(state, from4, -1);
let G__3259 = (function () {
 let test__23632__auto__10 = squint_core.nil_QMARK_(G__3258);
if (squint_core.t(test__23632__auto__10)) {
return null;} else {
return n.closest(G__3258, n.coll_QMARK_);}
})();
let test__23632__auto__11 = squint_core.nil_QMARK_(G__3259);
if (squint_core.t(test__23632__auto__11)) {
return null;} else {
return u.guard(G__3259, n.balanced_QMARK_);}
})();
if (squint_core.t(temp__25223__auto__7)) {
let nearest_balanced_coll12 = temp__25223__auto__7;
return ({ "cursor": (from4 - 1), "changes": [n.from_to(n.down(nearest_balanced_coll12)), n.from_to(n.down_last(nearest_balanced_coll12))] });}}
}));
});
var copy_to_clipboard_BANG_ = (function (text) {
let focus_el1 = squint_core.get(document, "activeElement");
let input_el2 = document.createElement("textarea");
input_el2.setAttribute("class", "clipboard-input");
squint_core.assoc_BANG_(input_el2, "innerHTML", text);
document.body.appendChild(input_el2);
input_el2.focus(({ "preventScroll": true }));
input_el2.select();
document.execCommand("copy");
focus_el1.focus(({ "preventScroll": true }));
return document.body.removeChild(input_el2);
});
var kill_STAR_ = (function (state) {
return u.update_ranges(state, (function (p__326) {
let map__12 = p__326;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
let node7 = n.tree(state, from4);
let parent8 = n.closest(node7, (function (_PERCENT_1) {
let or__25765__auto__9 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.t(or__25765__auto__9)) {
return or__25765__auto__9;} else {
let or__25765__auto__10 = n.string_QMARK_(_PERCENT_1);
if (squint_core.t(or__25765__auto__10)) {
return or__25765__auto__10;} else {
return n.top_QMARK_(_PERCENT_1);}}
}));
let line_end11 = state.doc.lineAt(from4).to;
let next_children12 = ((squint_core.t(parent8)) ? (n.children(parent8, from4, 1)) : (null));
let last_child_on_line13 = ((squint_core.t(parent8)) ? ((function () {
 let G__32714 = next_children12;
let G__32715 = (function () {
 let test__23632__auto__16 = squint_core.nil_QMARK_(G__32714);
if (squint_core.t(test__23632__auto__16)) {
return null;} else {
return squint_core.take_while(squint_core.every_pred((function (_PERCENT_1) {
return (n.start(_PERCENT_1) <= line_end11);
})), G__32714);}
})();
let test__23632__auto__17 = squint_core.nil_QMARK_(G__32715);
if (squint_core.t(test__23632__auto__17)) {
return null;} else {
return squint_core.last(G__32715);}
})()) : (null));
let to18 = (function () {
 let test__23632__auto__19 = n.string_QMARK_(parent8);
if (squint_core.t(test__23632__auto__19)) {
let content20 = squint_core.str(n.string(state, parent8));
let content_from21 = squint_core.subs(content20, (from4 - n.start(parent8)));
let next_newline22 = content_from21.indexOf("\n");
let test__23632__auto__23 = squint_core.neg_QMARK_(next_newline22);
if (squint_core.t(test__23632__auto__23)) {
return (n.end(parent8) - 1);} else {
return (from4 + next_newline22 + 1);}} else {
if (squint_core.t(last_child_on_line13)) {
let test__23632__auto__24 = n.end_edge_QMARK_(last_child_on_line13);
if (squint_core.t(test__23632__auto__24)) {
return n.start(last_child_on_line13);} else {
return n.end(last_child_on_line13);}} else {
let test__23632__auto__25 = (function () {
 let G__32826 = squint_core.first(next_children12);
let G__32827 = (function () {
 let test__23632__auto__28 = squint_core.nil_QMARK_(G__32826);
if (squint_core.t(test__23632__auto__28)) {
return null;} else {
return n.start(G__32826);}
})();
let test__23632__auto__29 = squint_core.nil_QMARK_(G__32827);
if (squint_core.t(test__23632__auto__29)) {
return null;} else {
return (G__32827 > line_end11);}
})();
if (squint_core.t(test__23632__auto__25)) {
return n.start(squint_core.first(next_children12));} else {
return null;}}}
})();
if (squint_core.t(u.node_js_QMARK_)) {
null} else {
copy_to_clipboard_BANG_(n.string(state, from4, to18))};
if (squint_core.t(to18)) {
return ({ "cursor": from4, "changes": ({ "from": from4, "to": to18 }) });}} else {
copy_to_clipboard_BANG_(n.string(state, from4, to5));
return ({ "cursor": from4, "changes": u.from_to(from4, to5) });}
}));
});
var enter_and_indent_STAR_ = (function (state) {
let ctx1 = format.make_indent_context(state);
return u.update_ranges(state, (function (p__329) {
let map__23 = p__329;
let range4 = map__23;
let from5 = squint_core.get(map__23, "from");
let to6 = squint_core.get(map__23, "to");
let empty7 = squint_core.get(map__23, "empty");
let indent_at8 = (function () {
 let G__3309 = n.closest(n.tree(state, from5), squint_core.some_fn(n.coll_QMARK_, n.top_QMARK_));
let G__33010 = (function () {
 let test__23632__auto__11 = squint_core.nil_QMARK_(G__3309);
if (squint_core.t(test__23632__auto__11)) {
return null;} else {
return n.inner_span(G__3309);}
})();
let test__23632__auto__12 = squint_core.nil_QMARK_(G__33010);
if (squint_core.t(test__23632__auto__12)) {
return null;} else {
return n.start(G__33010);}
})();
let indent13 = ((squint_core.t(indent_at8)) ? (format.get_indentation(ctx1, indent_at8)) : (null));
let insertion14 = squint_core.str("\n", ((squint_core.t(indent13)) ? (format.spaces(state, indent13)) : (null)));
return ({ "cursor": (from5 + squint_core.count(insertion14)), "changes": [({ "from": from5, "to": to6, "insert": insertion14 })] });
}));
});
var nav_position = (function (state, from, dir) {
let or__25765__auto__1 = (function () {
 let G__3312 = n.closest(n.tree(state, from), (function (_PERCENT_1) {
let or__25765__auto__3 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.t(or__25765__auto__3)) {
return or__25765__auto__3;} else {
let or__25765__auto__4 = n.string_QMARK_(_PERCENT_1);
if (squint_core.t(or__25765__auto__4)) {
return or__25765__auto__4;} else {
return n.top_QMARK_(_PERCENT_1);}}
}));
let G__3315 = (function () {
 let test__23632__auto__6 = squint_core.nil_QMARK_(G__3312);
if (squint_core.t(test__23632__auto__6)) {
return null;} else {
return n.children(G__3312, from, dir);}
})();
let G__3317 = (function () {
 let test__23632__auto__8 = squint_core.nil_QMARK_(G__3315);
if (squint_core.t(test__23632__auto__8)) {
return null;} else {
return squint_core.first(G__3315);}
})();
let test__23632__auto__9 = squint_core.nil_QMARK_(G__3317);
if (squint_core.t(test__23632__auto__9)) {
return null;} else {
return squint_core.get(G__3317, (function () {
 let G__33210 = dir;
switch (G__33210) {case -1:
return "from";
break;
case 1:
return "to";
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__33210))}
})());}
})();
if (squint_core.t(or__25765__auto__1)) {
return or__25765__auto__1;} else {
return sel.constrain(state, (from + dir));}
});
var nav = (function (dir) {
return function (state) {
return u.update_ranges(state, (function (p__333) {
let map__12 = p__333;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
return ({ "cursor": nav_position(state, from4, dir) });} else {
return ({ "cursor": squint_core.get(u.from_to(from4, to5), (function () {
 let G__3347 = dir;
switch (G__3347) {case -1:
return "from";
break;
case 1:
return "to";
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__3347))}
})()) });}
}));
};
});
var nav_select = (function (dir) {
return function (state) {
return u.update_ranges(state, (function (p__335) {
let map__12 = p__335;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
return ({ "range": n.balanced_range(state, from4, nav_position(state, from4, dir)) });} else {
return ({ "range": (function () {
 let map__78 = u.from_to(from4, to5);
let from9 = squint_core.get(map__78, "from");
let to10 = squint_core.get(map__78, "to");
let G__33611 = dir;
switch (G__33611) {case 1:
return n.balanced_range(state, from9, nav_position(state, to10, dir));
break;
case -1:
return n.balanced_range(state, nav_position(state, from9, dir), to10);
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__33611))}
})() });}
}));
};
});
var balance_ranges = (function (state) {
return u.update_ranges(state, (function (p__337) {
let map__12 = p__337;
let from3 = squint_core.get(map__12, "from");
let to4 = squint_core.get(map__12, "to");
let empty5 = squint_core.get(map__12, "empty");
if (squint_core.t(empty5)) {
return null;} else {
return ({ "range": n.balanced_range(state, from3, to4) });}
}));
});
var log = console.log;
var slurp = (function (direction) {
return function (state) {
return u.update_ranges(state, (function (p__338) {
let map__12 = p__338;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
let temp__25223__auto__7 = n.closest(n.tree(state, from4), squint_core.every_pred(n.coll_QMARK_, (function (_PERCENT_1) {
return !(function () {
 let G__3398 = direction;
switch (G__3398) {case 1:
let G__34010 = _PERCENT_1;
let G__34011 = (function () {
 let test__23632__auto__12 = squint_core.nil_QMARK_(G__34010);
if (squint_core.t(test__23632__auto__12)) {
return null;} else {
return n.with_prefix(G__34010);}
})();
let G__34013 = (function () {
 let test__23632__auto__14 = squint_core.nil_QMARK_(G__34011);
if (squint_core.t(test__23632__auto__14)) {
return null;} else {
return n.right(G__34011);}
})();
let test__23632__auto__15 = squint_core.nil_QMARK_(G__34013);
if (squint_core.t(test__23632__auto__15)) {
return null;} else {
return n.end_edge_QMARK_(G__34013);}
break;
case -1:
let G__34116 = _PERCENT_1;
let G__34117 = (function () {
 let test__23632__auto__18 = squint_core.nil_QMARK_(G__34116);
if (squint_core.t(test__23632__auto__18)) {
return null;} else {
return n.with_prefix(G__34116);}
})();
let G__34119 = (function () {
 let test__23632__auto__20 = squint_core.nil_QMARK_(G__34117);
if (squint_core.t(test__23632__auto__20)) {
return null;} else {
return n.left(G__34117);}
})();
let test__23632__auto__21 = squint_core.nil_QMARK_(G__34119);
if (squint_core.t(test__23632__auto__21)) {
return null;} else {
return n.start_edge_QMARK_(G__34119);}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__3398))}
})();
})));
if (squint_core.t(temp__25223__auto__7)) {
let parent22 = temp__25223__auto__7;
let temp__25223__auto__23 = (function () {
 let G__34224 = direction;
switch (G__34224) {case 1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.rights(n.with_prefix(parent22))));
break;
case -1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.lefts(n.with_prefix(parent22))));
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__34224))}
})();
if (squint_core.t(temp__25223__auto__23)) {
let target26 = temp__25223__auto__23;
return ({ "cursor/mapped": from4, "changes": (function () {
 let G__34327 = direction;
switch (G__34327) {case 1:
let edge29 = n.down_last(parent22);
return [({ "from": n.end(target26), "insert": n.name(edge29) }), squint_core.assoc_BANG_(n.from_to(edge29), "insert", " ")];
break;
case -1:
let edge30 = n.left_edge_with_prefix(state, parent22);
let start31 = n.start(n.with_prefix(parent22));
return [({ "from": start31, "to": (start31 + squint_core.count(edge30)), "insert": " " }), ({ "from": n.start(target26), "insert": edge30 })];
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__34327))}
})() });}}}
}));
};
});
var barf = (function (direction) {
return function (state) {
return u.update_ranges(state, (function (p__344) {
let map__12 = p__344;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.t(empty6)) {
let temp__25223__auto__7 = n.closest(n.tree(state, from4), n.coll_QMARK_);
if (squint_core.t(temp__25223__auto__7)) {
let parent8 = temp__25223__auto__7;
let G__3459 = direction;
switch (G__3459) {case 1:
let temp__25223__auto__11 = (function () {
 let G__34612 = n.down_last(parent8);
let G__34613 = (function () {
 let test__23632__auto__14 = squint_core.nil_QMARK_(G__34612);
if (squint_core.t(test__23632__auto__14)) {
return null;} else {
return n.lefts(G__34612);}
})();
let G__34615 = (function () {
 let test__23632__auto__16 = squint_core.nil_QMARK_(G__34613);
if (squint_core.t(test__23632__auto__16)) {
return null;} else {
return squint_core.remove(n.line_comment_QMARK_, G__34613);}
})();
let G__34617 = (function () {
 let test__23632__auto__18 = squint_core.nil_QMARK_(G__34615);
if (squint_core.t(test__23632__auto__18)) {
return null;} else {
return squint_core.drop(1, G__34615);}
})();
let test__23632__auto__19 = squint_core.nil_QMARK_(G__34617);
if (squint_core.t(test__23632__auto__19)) {
return null;} else {
return squint_core.first(G__34617);}
})();
if (squint_core.t(temp__25223__auto__11)) {
let target20 = temp__25223__auto__11;
return ({ "cursor": squint_core.min(n.end(target20), from4), "changes": [({ "from": n.end(target20), "insert": n.name(n.down_last(parent8)) }), squint_core.assoc_BANG_(n.from_to(n.down_last(parent8)), "insert", " ")] });}
break;
case -1:
let temp__25223__auto__21 = (function () {
 let G__34722 = n.down(parent8);
let G__34723 = (function () {
 let test__23632__auto__24 = squint_core.nil_QMARK_(G__34722);
if (squint_core.t(test__23632__auto__24)) {
return null;} else {
return n.rights(G__34722);}
})();
let G__34725 = (function () {
 let test__23632__auto__26 = squint_core.nil_QMARK_(G__34723);
if (squint_core.t(test__23632__auto__26)) {
return null;} else {
return squint_core.remove(n.line_comment_QMARK_, G__34723);}
})();
let G__34727 = (function () {
 let test__23632__auto__28 = squint_core.nil_QMARK_(G__34725);
if (squint_core.t(test__23632__auto__28)) {
return null;} else {
return squint_core.drop(1, G__34725);}
})();
let test__23632__auto__29 = squint_core.nil_QMARK_(G__34727);
if (squint_core.t(test__23632__auto__29)) {
return null;} else {
return squint_core.first(G__34727);}
})();
if (squint_core.t(temp__25223__auto__21)) {
let next_first_child30 = temp__25223__auto__21;
let left_edge31 = n.left_edge_with_prefix(state, parent8);
let left_start32 = n.start(n.with_prefix(parent8));
return ({ "cursor": squint_core.max(from4, (n.start(next_first_child30) + (squint_core.count(left_edge31) + 1))), "changes": [({ "from": n.start(next_first_child30), "insert": squint_core.str(" ", left_edge31) }), ({ "from": left_start32, "to": (left_start32 + squint_core.count(left_edge31)), "insert": format.spaces(state, squint_core.count(left_edge31)) })] });}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__3459))}}}
}));
};
});
var builtin_index = ({ "cursorLineStart": commands.cursorLineStart, "cursorLineDown": commands.cursorLineDown, "selectAll": commands.selectAll, "selectLineUp": commands.selectLineUp, "cursorLineBoundaryForward": commands.cursorLineBoundaryForward, "selectLineBoundaryBackward": commands.selectLineBoundaryBackward, "deleteCharBackward": commands.deleteCharBackward, "insertNewlineAndIndent": commands.insertNewlineAndIndent, "cursorLineBoundaryBackward": commands.cursorLineBoundaryBackward, "selectCharRight": commands.selectCharRight, "selectPageUp": commands.selectPageUp, "deleteCharForward": commands.deleteCharForward, "cursorCharLeft": commands.cursorCharLeft, "cursorGroupBackward": commands.cursorGroupBackward, "selectDocStart": commands.selectDocStart, "selectGroupBackward": commands.selectGroupBackward, "cursorDocEnd": commands.cursorDocEnd, "deleteGroupBackward": commands.deleteGroupBackward, "selectLineStart": commands.selectLineStart, "deleteGroupForward": commands.deleteGroupForward, "selectDocEnd": commands.selectDocEnd, "selectPageDown": commands.selectPageDown, "cursorPageDown": commands.cursorPageDown, "cursorPageUp": commands.cursorPageUp, "selectLineBoundaryForward": commands.selectLineBoundaryForward, "cursorLineEnd": commands.cursorLineEnd, "cursorGroupForward": commands.cursorGroupForward, "cursorCharRight": commands.cursorCharRight, "selectGroupForward": commands.selectGroupForward, "selectLineEnd": commands.selectLineEnd, "selectCharLeft": commands.selectCharLeft, "splitLine": commands.splitLine, "selectLineDown": commands.selectLineDown, "transposeChars": commands.transposeChars, "cursorLineUp": commands.cursorLineUp, "cursorDocStart": commands.cursorDocStart });
var indent = view_command(format.format);
var unwrap = view_command(unwrap_STAR_);
var kill = scoped_view_command(kill_STAR_);
var nav_right = view_command(nav(1));
var nav_left = view_command(nav(-1));
var nav_select_right = view_command(nav_select(1));
var nav_select_left = view_command(nav_select(-1));
var slurp_forward = view_command(slurp(1));
var slurp_backward = view_command(slurp(-1));
var barf_forward = view_command(barf(1));
var barf_backward = view_command(barf(-1));
var selection_grow = view_command(sel_history.selection_grow_STAR_);
var selection_return = view_command(sel_history.selection_return_STAR_);
var enter_and_indent = view_command(enter_and_indent_STAR_);
var paredit_index = ({ "indent": indent, "nav-left": nav_left, "enter-and-indent": enter_and_indent, "selection-grow": selection_grow, "kill": kill, "slurp-forward": slurp_forward, "nav-select-right": nav_select_right, "nav-select-left": nav_select_left, "barf-forward": barf_forward, "barf-backward": barf_backward, "nav-right": nav_right, "slurp-backward": slurp_backward, "unwrap": unwrap, "selection-return": selection_return });
var index = squint_core.merge(builtin_index, paredit_index);
var reverse_index = squint_core.reduce_kv((function (_PERCENT_1, _PERCENT_2, _PERCENT_3) {
return squint_core.assoc(_PERCENT_1, _PERCENT_3, _PERCENT_2);
}), ({  }), index);

export { nav_select_left, index, view_command, barf_backward, scoped_view_command, kill_STAR_, enter_and_indent_STAR_, unwrap, enter_and_indent, log, nav_select, slurp, nav_position, indent, nav_select_right, slurp_forward, selection_grow, nav, balance_ranges, nav_left, copy_to_clipboard_BANG_, barf, builtin_index, barf_forward, paredit_index, kill, reverse_index, unwrap_STAR_, nav_right, slurp_backward, selection_return }
