import * as squint_core from 'squint-cljs/core.js';
import * as state from '@codemirror/state';
import { StateEffect, StateField } from '@codemirror/state';
import * as view from '@codemirror/view';
import { EditorView, Decoration, keymap } from '@codemirror/view';
import { keyName } from 'w3c-keyname';
import * as u from './../util.mjs';
import * as n from './../node.mjs';
import * as str from 'squint-cljs/string.js';
var uppermost_edge_here = (function (pos, node) {
let or__25765__auto__1 = squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.complement(n.top_QMARK_), (function (_PERCENT_1) {
let or__25765__auto__2 = ((pos === n.end(_PERCENT_1)) && (n.end(_PERCENT_1) === n.end(node)));
if (squint_core.t(or__25765__auto__2)) {
return or__25765__auto__2;} else {
((pos === n.start(_PERCENT_1)) && (n.start(_PERCENT_1) === n.start(node)))}
})), squint_core.iterate(n.up, node)));
if (squint_core.t(or__25765__auto__1)) {
return or__25765__auto__1;} else {
return node;}
});
var main_selection = (function (state) {
return squint_core.get_in((function () {
 let parent__141__auto__1 = squint_core.get_in(state, ["selection"]);
let f__142__auto__2 = squint_core.get(parent__141__auto__1, "asSingle");
return f__142__auto__2.call(parent__141__auto__1);
})(), ["ranges", 0]);
});
var node_at_cursor = (function () {
 let f443 = (function (var_args) {
let G__4461 = arguments.length;
switch (G__4461) {case 1:
return f443.cljs$core$IFn$_invoke$arity$1((arguments[0]));
break;
case 2:
return f443.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f443.cljs$core$IFn$_invoke$arity$1 = (function (state) {
return node_at_cursor(state, squint_core.get(main_selection(state), "from"));
});
f443.cljs$core$IFn$_invoke$arity$2 = (function (state, from) {
let G__4473 = n.nearest_touching(state, from, -1);
let G__4474 = (function () {
 let test__23632__auto__5 = squint_core.nil_QMARK_(G__4473);
if (squint_core.t(test__23632__auto__5)) {
return null;} else {
return (function (_PERCENT_1) {
let test__23632__auto__6 = (function () {
 let or__25765__auto__7 = n.terminal_type_QMARK_(n.type(_PERCENT_1));
if (squint_core.t(or__25765__auto__7)) {
return or__25765__auto__7;} else {
let or__25765__auto__8 = (n.start(_PERCENT_1) <= from);
if (squint_core.t(or__25765__auto__8)) {
return or__25765__auto__8;} else {
return (n.end(_PERCENT_1) <= from);}}
})();
if (squint_core.t(test__23632__auto__6)) {
let G__4489 = _PERCENT_1;
let test__23632__auto__10 = (function () {
 let or__25765__auto__11 = n.top_QMARK_(_PERCENT_1);
if (squint_core.t(or__25765__auto__11)) {
return or__25765__auto__11;} else {
let and__25778__auto__12 = !n.terminal_type_QMARK_(n.type(_PERCENT_1));
if (squint_core.t(and__25778__auto__12)) {
((n.start(_PERCENT_1) < from) && (from < n.end(_PERCENT_1)))} else {
return and__25778__auto__12;}}
})();
if (squint_core.t(test__23632__auto__10)) {
return squint_core.first(n.children(G__4489, from, -1));} else {
return G__4489;}}
})(G__4473);}
})();
let G__44713 = (function () {
 let test__23632__auto__14 = squint_core.nil_QMARK_(G__4474);
if (squint_core.t(test__23632__auto__14)) {
return null;} else {
return uppermost_edge_here(from, G__4474);}
})();
let test__23632__auto__15 = squint_core.nil_QMARK_(G__44713);
if (squint_core.t(test__23632__auto__15)) {
return null;} else {
return n.balanced_range(state, G__44713);}
});
f443.cljs$lang$maxFixedArity = 2;
return f443;
})();
var top_level_node = (function (state) {
return squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.identity, squint_core.complement(n.top_QMARK_)), squint_core.iterate(n.up, n.nearest_touching(state, squint_core.get(main_selection(state), "from"), -1))));
});
var modifier_effect;
var modifier_effect = StateEffect.define();
var modifier_field;
var modifier_field = StateField.define(({ "create": squint_core.constantly(({  })), "update": (function (value, tr) {
let or__25765__auto__1 = (function () {
 let G__4492 = squint_core.first(squint_core.filter((function (_PERCENT_1) {
return _PERCENT_1.is(modifier_effect);
}), tr.effects));
let test__23632__auto__3 = squint_core.nil_QMARK_(G__4492);
if (squint_core.t(test__23632__auto__3)) {
return null;} else {
return squint_core.get(G__4492, "value");}
})();
if (squint_core.t(or__25765__auto__1)) {
return or__25765__auto__1;} else {
return value;}
}) }));
var get_modifier_field = (function (state) {
return state.field(modifier_field);
});
var set_modifier_field_BANG_ = (function (p__450, value) {
let map__12 = p__450;
let _view3 = map__12;
let dispatch4 = squint_core.get(map__12, "dispatch");
return dispatch4(({ "effects": modifier_effect.of(value), "userEvent": "evalregion" }));
});
var mark = (function (spec, p__451) {
let map__12 = p__451;
let from3 = squint_core.get(map__12, "from");
let to4 = squint_core.get(map__12, "to");
return Decoration.mark(spec).range(from3, to4);
});
var single_mark = (function (spec, range) {
return Decoration.set([mark(spec, range)]);
});
var mark_spec;
var mark_spec = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.14);" }) });
var mark_spec_highlight;
var mark_spec_highlight = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.35);" }) });
var cursor_range = (function (state) {
let test__23632__auto__1 = state.selection.main.empty;
if (squint_core.t(test__23632__auto__1)) {
return node_at_cursor(state);} else {
return state.selection.main;}
});
var region_field;
var region_field = StateField.define(({ "create": squint_core.constantly(Decoration.none), "update": (function (_value, p__452) {
let map__12 = p__452;
let state3 = squint_core.get(map__12, "state");
let map__45 = get_modifier_field(state3);
let field6 = map__45;
let Shift7 = squint_core.get(map__45, "Shift");
let Enter8 = squint_core.get(map__45, "Enter");
let modifier9 = squint_core.get(map__45, "modifier");
let modifier_pressed_QMARK_10 = squint_core.get(field6, modifier9);
let spec11 = ((squint_core.t(Enter8)) ? (mark_spec_highlight) : (mark_spec));
let temp__25197__auto__12 = (function () {
 let test__23632__auto__13 = (function () {
 let or__25765__auto__14 = n.embedded_QMARK_(state3);
if (squint_core.t(or__25765__auto__14)) {
return or__25765__auto__14;} else {
return n.within_program_QMARK_(state3);}
})();
if (squint_core.t(test__23632__auto__13)) {
let test__23632__auto__15 = (function () {
 let and__25778__auto__16 = modifier_pressed_QMARK_10;
if (squint_core.t(and__25778__auto__16)) {
return Shift7;} else {
return and__25778__auto__16;}
})();
if (squint_core.t(test__23632__auto__15)) {
return top_level_node(state3);} else {
if (squint_core.t(modifier_pressed_QMARK_10)) {
let or__25765__auto__17 = u.guard(main_selection(state3), (function (_PERCENT_1) {
return !squint_core.get(_PERCENT_1, "empty");
}));
if (squint_core.t(or__25765__auto__17)) {
return or__25765__auto__17;} else {
return cursor_range(state3);}} else {
return null;}}}
})();
let test__23632__auto__18 = squint_core.nil_QMARK_(temp__25197__auto__12);
if (squint_core.t(test__23632__auto__18)) {
return Decoration.none;} else {
let range19 = temp__25197__auto__12;
return single_mark(spec11, range19);}
}) }));
var get_region_field = (function (state) {
return state.field(region_field);
});
var current_range = (function (state) {
let or__25765__auto__1 = (function () {
 let G__4532 = get_region_field(state);
let G__4533 = (function () {
 let test__23632__auto__4 = squint_core.nil_QMARK_(G__4532);
if (squint_core.t(test__23632__auto__4)) {
return null;} else {
return G__4532.iter();}
})();
let test__23632__auto__5 = squint_core.nil_QMARK_(G__4533);
if (squint_core.t(test__23632__auto__5)) {
return null;} else {
return u.guard(G__4533, (function (_PERCENT_1) {
return squint_core.get(_PERCENT_1, "value");
}));}
})();
if (squint_core.t(or__25765__auto__1)) {
return or__25765__auto__1;} else {
return state.selection.main;}
});
var modifier_extension = (function (modifier) {
let handle_enter1 = (function handle_enter (p__454) {
let map__23 = p__454;
let view4 = map__23;
let state5 = squint_core.get(map__23, "state");
set_modifier_field_BANG_(view4, squint_core.assoc(get_modifier_field(state5), "Enter", true));
return null;
});
let handle_key_event6 = (function (p__455, p__456) {
let map__79 = p__455;
let event10 = map__79;
let altKey11 = squint_core.get(map__79, "altKey");
let shiftKey12 = squint_core.get(map__79, "shiftKey");
let metaKey13 = squint_core.get(map__79, "metaKey");
let controlKey14 = squint_core.get(map__79, "controlKey");
let type15 = squint_core.get(map__79, "type");
let map__816 = p__456;
let view17 = map__816;
let state18 = squint_core.get(map__816, "state");
let prev19 = get_modifier_field(state18);
let next20 = (function () {
 let G__45721 = ({ "modifier": modifier });
let G__45722 = ((squint_core.t(altKey11)) ? (squint_core.assoc(G__45721, "Alt", true)) : (G__45721));
let G__45723 = ((squint_core.t(shiftKey12)) ? (squint_core.assoc(G__45722, "Shift", true)) : (G__45722));
let G__45724 = ((squint_core.t(metaKey13)) ? (squint_core.assoc(G__45723, "Meta", true)) : (G__45723));
let G__45725 = ((squint_core.t(controlKey14)) ? (squint_core.assoc(G__45724, "Control", true)) : (G__45724));
let test__23632__auto__26 = (function () {
 let and__25778__auto__27 = ("keydown" === type15);
if (squint_core.t(and__25778__auto__27)) {
return ("Enter" === keyName(event10));} else {
return and__25778__auto__27;}
})();
if (squint_core.t(test__23632__auto__26)) {
return squint_core.assoc(G__45725, "Enter", true);} else {
return G__45725;}
})();
let test__23632__auto__28 = (prev19 !== next20);
if (squint_core.t(test__23632__auto__28)) {
set_modifier_field_BANG_(view17, next20)};
return false;
});
let handle_backspace29 = (function (p__458) {
let map__3031 = p__458;
let _view32 = map__3031;
let state33 = squint_core.get(map__3031, "state");
let dispatch34 = squint_core.get(map__3031, "dispatch");
let map__3536 = current_range(state33);
let from37 = squint_core.get(map__3536, "from");
let to38 = squint_core.get(map__3536, "to");
let test__23632__auto__39 = (from37 !== to38);
if (squint_core.t(test__23632__auto__39)) {
dispatch34(({ "changes": ({ "from": from37, "to": to38, "insert": "" }), "annotations": u.user_event_annotation("delete") }))};
return true;
});
return [modifier_field, keymap.of([({ "key": squint_core.str(modifier, "-Enter"), "shift": handle_enter1, "run": handle_enter1 }), ({ "key": squint_core.str(modifier, "-Backspace"), "run": handle_backspace29, "shift": handle_backspace29 })]), view.EditorView.domEventHandlers(({ "keydown": handle_key_event6, "keyup": handle_key_event6 }))];
});
var extension = (function (p__459) {
let map__12 = p__459;
let modifier3 = squint_core.get(map__12, "modifier", "Meta");
return [modifier_extension(modifier3), region_field, EditorView.decorations.from(region_field)];
});
var cursor_node_string = (function (state) {
return u.guard((function () {
 let G__4601 = node_at_cursor(state);
let test__23632__auto__2 = squint_core.nil_QMARK_(G__4601);
if (squint_core.t(test__23632__auto__2)) {
return null;} else {
return u.range_str(state, G__4601);}
})(), squint_core.complement(str.blank_QMARK_));
});
var top_level_string = (function (state) {
return u.guard((function () {
 let G__4611 = top_level_node(state);
let test__23632__auto__2 = squint_core.nil_QMARK_(G__4611);
if (squint_core.t(test__23632__auto__2)) {
return null;} else {
return u.range_str(state, G__4611);}
})(), squint_core.complement(str.blank_QMARK_));
});

export { top_level_node, current_range, set_modifier_field_BANG_, cursor_range, modifier_field, mark_spec_highlight, modifier_extension, extension, node_at_cursor, region_field, get_modifier_field, get_region_field, main_selection, mark_spec, mark, top_level_string, single_mark, uppermost_edge_here, cursor_node_string, modifier_effect }
