import * as squint_core from 'squint-cljs/core.js';
import { StateField } from '@codemirror/state';
import { EditorView, Decoration } from '@codemirror/view';
import * as n from './../node.mjs';
import * as u from './../util.mjs';
var base_theme = EditorView.baseTheme(({ "$matchingBracket": ({ "color": "#0b0" }), "$nonmatchingBracket": ({ "color": "#a22" }) }));
var matching_mark = Decoration.mark(squint_core.js_obj("class", "cm-matchingBracket"));
var nonmatching_mark = Decoration.mark(squint_core.js_obj("class", "cm-nonmatchingBracket"));
var mark_node = (function (node, mark) {
return mark.range(n.start(node), n.end(node));
});
var state = StateField.define(({ "create": squint_core.constantly(Decoration.none), "update": (function (deco, p__477) {
let map__12 = p__477;
let tr3 = map__12;
let state4 = squint_core.get(map__12, "state");
let docChanged5 = squint_core.get(map__12, "docChanged");
let selection6 = squint_core.get(map__12, "selection");
let test__23632__auto__7 = (function () {
 let or__25765__auto__8 = docChanged5;
if (squint_core.t(or__25765__auto__8)) {
return or__25765__auto__8;} else {
return selection6;}
})();
if (squint_core.t(test__23632__auto__7)) {
let decos9 = squint_core.reduce((function (out, p__478) {
let map__1011 = p__478;
let head12 = squint_core.get(map__1011, "head");
let empty13 = squint_core.get(map__1011, "empty");
let or__25765__auto__14 = (function () {
 let temp__25223__auto__15 = (function () {
 let and__25778__auto__16 = empty13;
if (squint_core.t(and__25778__auto__16)) {
return squint_core.first(squint_core.filter(squint_core.some_fn(n.start_edge_QMARK_, n.end_edge_QMARK_), [n.tree(state4, head12, -1), n.tree(state4, head12, 1)]));} else {
return and__25778__auto__16;}
})();
if (squint_core.t(temp__25223__auto__15)) {
let bracket17 = temp__25223__auto__15;
let temp__25183__auto__18 = (function () {
 let test__23632__auto__19 = (function () {
 let and__25778__auto__20 = n.start_edge_QMARK_(bracket17);
if (squint_core.t(and__25778__auto__20)) {
return (n.start(bracket17) === n.start(n.up(bracket17)));} else {
return and__25778__auto__20;}
})();
if (squint_core.t(test__23632__auto__19)) {
return u.guard(n.down_last(n.up(bracket17)), (function (_PERCENT_1) {
return (n.name(_PERCENT_1) === n.closed_by(bracket17));
}));} else {
let test__23632__auto__21 = (function () {
 let and__25778__auto__22 = n.end_edge_QMARK_(bracket17);
if (squint_core.t(and__25778__auto__22)) {
return (n.end(bracket17) === n.end(n.up(bracket17)));} else {
return and__25778__auto__22;}
})();
if (squint_core.t(test__23632__auto__21)) {
return u.guard(n.down(n.up(bracket17)), (function (_PERCENT_1) {
return (n.name(_PERCENT_1) === n.opened_by(bracket17));
}));} else {
return null;}}
})();
if (squint_core.t(temp__25183__auto__18)) {
let other_bracket23 = temp__25183__auto__18;
return squint_core.conj(out, mark_node(bracket17, matching_mark), mark_node(other_bracket23, matching_mark));} else {
return squint_core.conj(out, mark_node(bracket17, nonmatching_mark));}}
})();
if (squint_core.t(or__25765__auto__14)) {
return or__25765__auto__14;} else {
let or__25765__auto__24 = (function () {
 let temp__25223__auto__25 = (function () {
 let and__25778__auto__26 = !n.closest(n.tree(state4, head12), n.string_QMARK_);
if (squint_core.t(and__25778__auto__26)) {
return squint_core.contains_QMARK_(new Set(["]", ")", "}"]), tr3.state.doc.slice(head12, (head12 + 1)).toString());} else {
return and__25778__auto__26;}
})();
if (squint_core.t(temp__25223__auto__25)) {
let _unparsed_bracket27 = temp__25223__auto__25;
return squint_core.conj(out, mark_node(n.from_to(head12, (head12 + 1)), nonmatching_mark));}
})();
if (squint_core.t(or__25765__auto__24)) {
return or__25765__auto__24;} else {
return out;}}
}), [], tr3.state.selection.ranges);
return Decoration.set(squint_core.into_array(decos9), true);} else {
return deco;}
}) }));
var extension = (function () {
return [base_theme, state, EditorView.decorations.from(state)];
});

export { base_theme, matching_mark, nonmatching_mark, mark_node, state, extension }
