import * as squint_core from 'squint-cljs/core.js';
import { EditorSelection, StateEffect, Transaction } from '@codemirror/state';
import * as sel from './selections.mjs';
var node_js_QMARK_ = squint_core.some_QMARK_(globalThis.process);
var user_event_annotation = (function (event_name) {
return Transaction.userEvent.of(event_name);
});
var get_user_event_annotation = (function (tr) {
return tr.annotation(Transaction.userEvent);
});
var guard = (function (x, f) {
let test__23632__auto__1 = f(x);
if (squint_core.t(test__23632__auto__1)) {
return x;}
});
var from_to = (function (p1, p2) {
let test__23632__auto__1 = (p1 > p2);
if (squint_core.t(test__23632__auto__1)) {
return ({ "from": p2, "to": p1 });} else {
return ({ "from": p1, "to": p2 });}
});
var dispatch_some = (function (view, tr) {
if (squint_core.t(tr)) {
view.dispatch(tr);
return true;} else {
return false;}
});
var insertion = (function () {
 let f403 = (function (var_args) {
let G__4061 = arguments.length;
switch (G__4061) {case 2:
return f403.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
case 3:
return f403.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f403.cljs$core$IFn$_invoke$arity$2 = (function (from, s) {
return insertion(from, from, s);
});
f403.cljs$core$IFn$_invoke$arity$3 = (function (from, to, s) {
return ({ "changes": ({ "insert": s, "from": from, "to": to }), "cursor": (from + squint_core.count(s)) });
});
f403.cljs$lang$maxFixedArity = 3;
return f403;
})();
var deletion = (function () {
 let f407 = (function (var_args) {
let G__4101 = arguments.length;
switch (G__4101) {case 1:
return f407.cljs$core$IFn$_invoke$arity$1((arguments[0]));
break;
case 2:
return f407.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f407.cljs$core$IFn$_invoke$arity$1 = (function (from) {
return deletion(squint_core.max(0, (from - 1)), from);
});
f407.cljs$core$IFn$_invoke$arity$2 = (function (from, to) {
let from3 = (function () {
 let test__23632__auto__4 = (from === to);
if (squint_core.t(test__23632__auto__4)) {
return squint_core.max(0, (from - 1));} else {
return from;}
})();
return ({ "cursor": from3, "changes": ({ "from": from3, "to": to }) });
});
f407.cljs$lang$maxFixedArity = 2;
return f407;
})();
var line_content_at = (function (state, from) {
return (function () {
 let parent__141__auto__1 = squint_core.get_in(state, ["doc"]);
let f__142__auto__2 = squint_core.get(parent__141__auto__1, "lineAt");
return f__142__auto__2.call(parent__141__auto__1, from);
})().slice();
});
var map_cursor = (function (original_range, state, update_map) {
let test__23632__auto__1 = squint_core.map_QMARK_(update_map);
if (squint_core.t(test__23632__auto__1)) {
null} else {
throw new Error("Assert failed: (map? update-map)")};
let map__23 = guard(update_map, squint_core.map_QMARK_);
let mapped4 = squint_core.get(map__23, "cursor/mapped");
let cursor5 = squint_core.get(map__23, "cursor");
let from_to6 = squint_core.get(map__23, "from-to");
let range7 = squint_core.get(map__23, "range");
let changes8 = squint_core.get(map__23, "changes");
let change_desc9 = ((squint_core.t(changes8)) ? (state.changes(changes8)) : (null));
let G__41110 = ({ "range": (function () {
 let or__25765__auto__11 = range7;
if (squint_core.t(or__25765__auto__11)) {
return or__25765__auto__11;} else {
let or__25765__auto__12 = ((squint_core.t(mapped4)) ? (sel.cursor(change_desc9.mapPos(mapped4))) : (((squint_core.t(cursor5)) ? (sel.cursor(cursor5)) : (((squint_core.t(from_to6)) ? (sel.range(from_to6(0), from_to6(1))) : (null))))));
if (squint_core.t(or__25765__auto__12)) {
return or__25765__auto__12;} else {
return original_range;}}
})() });
if (squint_core.t(change_desc9)) {
G__41110.changes = change_desc9;
return G__41110;} else {
return G__41110;}
});
var update_ranges = (function () {
 let f412 = (function (var_args) {
let G__4151 = arguments.length;
switch (G__4151) {case 2:
return f412.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]));
break;
case 3:
return f412.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]));
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f412.cljs$core$IFn$_invoke$arity$2 = (function (state, f) {
return update_ranges(state, null, f);
});
f412.cljs$core$IFn$_invoke$arity$3 = (function (state, tr_specs, f) {
return state.update((function (_PERCENT_1) {
return Object.assign(_PERCENT_1, tr_specs);
})(state.changeByRange((function (range) {
let or__25765__auto__3 = (function () {
 let temp__25250__auto__4 = f(range);
let test__23632__auto__5 = squint_core.nil_QMARK_(temp__25250__auto__4);
if (squint_core.t(test__23632__auto__5)) {
return null;} else {
let result6 = temp__25250__auto__4;
return map_cursor(range, state, result6);}
})();
if (squint_core.t(or__25765__auto__3)) {
return or__25765__auto__3;} else {
return ({ "range": range });}
}))));
});
f412.cljs$lang$maxFixedArity = 3;
return f412;
})();
var dispatch_changes = (function (state, dispatch, changes) {
let test__23632__auto__1 = changes.empty;
if (squint_core.t(test__23632__auto__1)) {
return null;} else {
return dispatch(state.update(({ "changes": changes })));}
});
var update_lines = (function () {
 let f416 = (function (var_args) {
let args4171 = [];
let len__24819__auto__2 = arguments.length;
let i4183 = 0;
while(true){
let test__23632__auto__4 = (i4183 < len__24819__auto__2);
if (squint_core.t(test__23632__auto__4)) {
args4171.push((arguments[i4183]));
let G__5 = (i4183 + 1);
i4183 = G__5;
continue;
};break;
}
;
let argseq__25137__auto__6 = (function () {
 let test__23632__auto__7 = (2 < args4171.length);
if (squint_core.t(test__23632__auto__7)) {
return args4171.slice(2);}
})();
return f416.cljs$core$IFn$_invoke$arity$variadic((arguments[0]), (arguments[1]), argseq__25137__auto__6);
});
f416.cljs$core$IFn$_invoke$arity$variadic = (function (state, f, p__422) {
let vec__812 = p__422;
let map__1113 = squint_core.nth(vec__812, 0, null);
let from14 = squint_core.get(map__1113, "from", 0);
let to15 = squint_core.get(map__1113, "to");
let spec16 = squint_core.get(map__1113, "spec");
let iterator17 = state.doc.iter();
let result18 = iterator17.next();
let changes19 = [];
let from_pos20 = from14;
let line_num21 = 1;
while(true){
let map__2223 = result18;
let done24 = squint_core.get(map__2223, "done");
let lineBreak25 = squint_core.get(map__2223, "lineBreak");
let value26 = squint_core.get(map__2223, "value");
let test__23632__auto__27 = (function () {
 let or__25765__auto__28 = done24;
if (squint_core.t(or__25765__auto__28)) {
return or__25765__auto__28;} else {
return (from14 > to15);}
})();
if (squint_core.t(test__23632__auto__27)) {
return state.update(Object.assign(({ "changes": state.changes(changes19) }), spec16));} else {
let G__29 = iterator17.next();
let G__30 = (function () {
 let temp__25183__auto__31 = (function () {
 let and__25778__auto__32 = !lineBreak25;
if (squint_core.t(and__25778__auto__32)) {
return f(from_pos20, value26, line_num21);} else {
return and__25778__auto__32;}
})();
if (squint_core.t(temp__25183__auto__31)) {
let change33 = temp__25183__auto__31;
let G__42334 = changes19;
G__42334.push(change33);
return G__42334;} else {
return changes19;}
})();
let G__35 = (from_pos20 + squint_core.count(value26));
let G__36 = (function () {
 let G__42437 = line_num21;
if (squint_core.t(lineBreak25)) {
return (G__42437 + 1);} else {
return G__42437;}
})();
result18 = G__29;
changes19 = G__30;
from_pos20 = G__35;
line_num21 = G__36;
continue;
};break;
}

});
f416.cljs$lang$maxFixedArity = 2;
f416.cljs$lang$applyTo = (function (seq419) {
let G__42038 = squint_core.first(seq419);
let seq41939 = squint_core.next(seq419);
let G__42140 = squint_core.first(seq41939);
let seq41941 = squint_core.next(seq41939);
let self__24839__auto__42 = this;
return self__24839__auto__42.cljs$core$IFn$_invoke$arity$variadic(G__42038, G__42140, seq41941);
});
return f416;
})();
var update_selected_lines = (function (state, f) {
let at_line1 = squint_core.atom(-1);
let doc2 = state.doc;
return state.changeByRange((function (p__425) {
let map__34 = p__425;
let range5 = map__34;
let from6 = squint_core.get(map__34, "from");
let to7 = squint_core.get(map__34, "to");
let anchor8 = squint_core.get(map__34, "anchor");
let head9 = squint_core.get(map__34, "head");
let changes10 = [];
let line11 = doc2.lineAt(from6);
while(true){
let map__1213 = line11;
let line_number14 = squint_core.get(map__1213, "number");
let line_to15 = squint_core.get(map__1213, "to");
let test__23632__auto__16 = (line11.number > squint_core.deref(at_line1));
if (squint_core.t(test__23632__auto__16)) {
squint_core.reset_BANG_(at_line1, line_number14);
f(line11, changes10, range5)};
let temp__25183__auto__17 = (function () {
 let and__25778__auto__18 = (to7 > line_to15);
if (squint_core.t(and__25778__auto__18)) {
return guard(doc2.lineAt((line_to15 + 1)), (function (_PERCENT_1) {
return (_PERCENT_1.number > line_number14);
}));} else {
return and__25778__auto__18;}
})();
if (squint_core.t(temp__25183__auto__17)) {
let next_line19 = temp__25183__auto__17;
let G__20 = next_line19;
line11 = G__20;
continue;
} else {
let change_set21 = state.changes(changes10);
return ({ "changes": changes10, "range": EditorSelection.range(change_set21.mapPos(anchor8, 1), change_set21.mapPos(head9, 1)) });};break;
}

}));
});
var iter_changed_lines = (function (p__426, f) {
let map__13 = p__426;
let tr4 = map__13;
let map__25 = squint_core.get(map__13, "state");
let state6 = map__25;
let doc7 = squint_core.get(map__25, "doc");
let changes8 = squint_core.get(map__13, "changes");
let effects9 = squint_core.get(map__13, "effects");
let selection10 = squint_core.get(map__13, "selection");
let at_line11 = squint_core.atom(-1);
let next_changes12 = [];
let _13 = changes8.iterChanges((function (_from_a, _to_a, from_b, to_b, _inserted) {
let map__1415 = doc7.lineAt(from_b);
let line16 = map__1415;
let line_number17 = squint_core.get(map__1415, "number");
let line_to18 = squint_core.get(map__1415, "to");
let line19 = line16;
while(true){
let test__23632__auto__20 = (line_number17 > squint_core.deref(at_line11));
if (squint_core.t(test__23632__auto__20)) {
squint_core.reset_BANG_(at_line11, line_number17);
f(line19, next_changes12)};
let test__23632__auto__21 = (to_b <= line_to18);
if (squint_core.t(test__23632__auto__21)) {
return null;} else {
let next_line22 = doc7.lineAt((line_to18 + 1));
let test__23632__auto__23 = (function () {
 let and__25778__auto__24 = next_line22;
if (squint_core.t(and__25778__auto__24)) {
return (next_line22.number > line19.number);} else {
return and__25778__auto__24;}
})();
if (squint_core.t(test__23632__auto__23)) {
let G__25 = next_line22;
line19 = G__25;
continue;
}};break;
}

}));
let next_changeset26 = state6.changes(next_changes12);
let test__23632__auto__27 = squint_core.seq(next_changes12);
if (squint_core.t(test__23632__auto__27)) {
let G__42728 = squint_core.assoc_BANG_(squint_core.select_keys(tr4, ["annotations", "scrollIntoView", "reconfigure"]), "changes", changes8.compose(next_changeset26));
let G__42729 = ((squint_core.t(selection10)) ? (squint_core.assoc_BANG_(G__42728, "selection", state6.selection.map(next_changeset26))) : (G__42728));
if (squint_core.t(effects9)) {
return squint_core.assoc_BANG_(G__42729, "effects", StateEffect.mapEffects(effects9, next_changeset26));} else {
return G__42729;}} else {
return tr4;}
});
var something_selected_QMARK_ = (function (p__428) {
let map__13 = p__428;
let map__24 = squint_core.get(map__13, "selection");
let ranges5 = squint_core.get(map__24, "ranges");
return !squint_core.every_QMARK_((function (_PERCENT_1) {
return _PERCENT_1.empty;
}), ranges5);
});
var range_str = (function (state, p__429) {
let map__12 = p__429;
let _selection3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
return squint_core.str((function () {
 let parent__141__auto__6 = squint_core.get_in(state, ["doc"]);
let f__142__auto__7 = squint_core.get(parent__141__auto__6, "slice");
return f__142__auto__7.call(parent__141__auto__6, from4, to5);
})());
});

export { dispatch_some, guard, node_js_QMARK_, dispatch_changes, insertion, deletion, line_content_at, update_selected_lines, map_cursor, get_user_event_annotation, user_event_annotation, update_ranges, from_to, iter_changed_lines, update_lines, range_str, something_selected_QMARK_ }
